package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type SpiderListenSymbol struct {
	api.Api
}

// GetPage 获取交易对监听列表
// @Summary 获取交易对监听列表
// @Description 获取交易对监听列表
// @Tags 交易对监听
// @Param symbol query string false "交易对"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.SpiderListenSymbol}} "{"code": 200, "data": [...]}"
// @Router /api/v1/spider-listen-symbol [get]
// @Security Bearer
func (e SpiderListenSymbol) GetPage(c *gin.Context) {
	req := dto.SpiderListenSymbolGetPageReq{}
	s := service.SpiderListenSymbol{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.SpiderListenSymbol, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取交易对监听失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取交易对监听
// @Summary 获取交易对监听
// @Description 获取交易对监听
// @Tags 交易对监听
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.SpiderListenSymbol} "{"code": 200, "data": [...]}"
// @Router /api/v1/spider-listen-symbol/{id} [get]
// @Security Bearer
func (e SpiderListenSymbol) Get(c *gin.Context) {
	req := dto.SpiderListenSymbolGetReq{}
	s := service.SpiderListenSymbol{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.SpiderListenSymbol

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取交易对监听失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建交易对监听
// @Summary 创建交易对监听
// @Description 创建交易对监听
// @Tags 交易对监听
// @Accept application/json
// @Product application/json
// @Param data body dto.SpiderListenSymbolInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/spider-listen-symbol [post]
// @Security Bearer
func (e SpiderListenSymbol) Insert(c *gin.Context) {
	req := dto.SpiderListenSymbolInsertReq{}
	s := service.SpiderListenSymbol{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	if err := req.Valid(); err != nil {
		e.Error(500, err, "")
		return
	}

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建交易对监听失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改交易对监听
// @Summary 修改交易对监听
// @Description 修改交易对监听
// @Tags 交易对监听
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.SpiderListenSymbolUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/spider-listen-symbol/{id} [put]
// @Security Bearer
func (e SpiderListenSymbol) Update(c *gin.Context) {
	req := dto.SpiderListenSymbolUpdateReq{}
	s := service.SpiderListenSymbol{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	if err := req.Valid(); err != nil {
		e.Error(500, err, "")
		return
	}

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改交易对监听失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除交易对监听
// @Summary 删除交易对监听
// @Description 删除交易对监听
// @Tags 交易对监听
// @Param data body dto.SpiderListenSymbolDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/spider-listen-symbol [delete]
// @Security Bearer
func (e SpiderListenSymbol) Delete(c *gin.Context) {
	s := service.SpiderListenSymbol{}
	req := dto.SpiderListenSymbolDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除交易对监听失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}
